"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _set = require("babel-runtime/core-js/set");

var _set2 = _interopRequireDefault(_set);

exports.default = function (_ref) {
  var t = _ref.types;

  var badCalls = new _set2.default();

  return {
    name: "transform-tinytime", // not required
    visitor: {
      ImportDeclaration: function ImportDeclaration(path) {
        if (!looksLike(path.node, { source: { value: "tinytime" } })) {
          return;
        }
        var defaultSpecifier = path.get("specifiers").find(function (p) {
          return p.isImportDefaultSpecifier();
        });
        if (!defaultSpecifier) {
          return;
        }
        var refs = defaultSpecifier.scope.getBinding(defaultSpecifier.node.local.name).referencePaths;
        refs.forEach(function (r) {
          if (r.findParent(t.isJSXElement) && r.parentPath.isCallExpression()) {
            badCalls.add(r.parentPath);
          }
        });
      },

      Program: {
        exit: function exit(program) {
          badCalls.forEach(function (call) {
            var id = program.scope.generateUidIdentifier("template");
            program.scope.push({ id: id, init: call.node });
            call.parent.object = id;
          });
        }
      }
    }
  };
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function looksLike(a, b) {
  return a && b && (0, _keys2.default)(b).every(function (bKey) {
    var bVal = b[bKey];
    var aVal = a[bKey];
    if (typeof bVal === "function") {
      return bVal(aVal);
    }
    return isPrimitive(bVal) ? bVal === aVal : looksLike(aVal, bVal);
  });
}

function isPrimitive(val) {
  return val == null || /^[sbn]/.test(typeof val === "undefined" ? "undefined" : (0, _typeof3.default)(val));
}